// =============================================================================
//
//  JagdGeschwader_FirstStartForm.pas
//
// =============================================================================
//
//   Copyright  2005 by Sascha Willems (www.delphigl.de)
//
// =============================================================================
//
//   Contents of this file are subject to the GNU Public License (GPL) which can
//   be obtained here : http://opensource.org/licenses/gpl-license.php
//
// =============================================================================
//
//   Entry for the 2005 PGD "Dog-Fight" Competition
//
// =============================================================================

unit JagdGeschwader_FirstStartForm;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  IniFiles,

  JagdGeschwader_Terrain,
  JagdGeschwader_GameClass, ExtCtrls, jpeg;

type
  TFirstStartForm = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    EditScenario: TLabel;
    StartTimer: TTimer;
    Image1: TImage;
    procedure StartTimerTimer(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
   procedure SerializeScenarios;
  end;

var
 FirstStartForm : TFirstStartForm;

function NeedSerializations : Boolean;

implementation

{$R *.dfm}

function NeedSerializations : Boolean;
var
 i : Integer;
begin
Result := False;
for i := 0 to High(GameClass.ScenarioName) do
 if not FileExists(ExtractFilePath(Application.ExeName)+'data\scenarios\'+GameClass.ScenarioName[i]+'\serialization.dat') then
  begin
  Result := True;
  break;
  end;
end;

procedure TFirstStartForm.SerializeScenarios;
var
 i       : Integer;
 Terrain : TTerrain;
 SizeScale : Single;
 HeightScale : Single;
 Offset : Integer;
 INI : TIniFile;
begin
for i := 0 to High(GameClass.ScenarioName) do
 if not FileExists(ExtractFilePath(Application.ExeName)+'data\scenarios\'+GameClass.ScenarioName[i]+'\serialization.dat') then
  begin
  ChDir(ExtractFilePath(Application.ExeName)+'data\scenarios\'+GameClass.ScenarioName[i]);
  EditScenario.Caption := GameClass.ScenarioName[i];
  RePaint;
  INI := TIniFile.Create(ExtractFilePath(Application.ExeName)+'data\scenarios\'+GameClass.ScenarioName[i]+'\settings.ini');
  SizeScale   := INI.ReadInteger('scenario', 'sizescale', 100)/100;
  HeightScale := INI.ReadInteger('scenario', 'heightscale', 100)/100;
  Offset      := INI.ReadInteger('scenario', 'terrainoffset', -50);
  INI.Free;
  Terrain := TTerrain.Create;
  Terrain.LoadFromFile('terrain.bmp', 'terrainbase.jpg', 'terraindetail.tga', GameClass.NewtonWorld, SizeScale, HeightScale, Offset, True);
  Terrain.Free;
  end;
ChDir(ExtractFilePath(Application.ExeName));
Close;
end;

procedure TFirstStartForm.StartTimerTimer(Sender: TObject);
begin
StartTimer.Enabled := False;
SerializeScenarios;
end;

end.
